from orchestrator import step
from orchestrator.types import State, UUIDstr
from pydantic import BaseModel

from gso.products.product_types.iptrunk import Iptrunk
from gso.services import provisioning_proxy


class LAGMember(BaseModel):
    #  TODO: validate interface name
    interface_name: str
    interface_description: str

    def __hash__(self) -> int:
        return hash((self.interface_name, self.interface_description))


@step("[COMMIT] Set ISIS metric to 90000")
def set_isis_to_90000(subscription: Iptrunk, process_id: UUIDstr, tt_number: str) -> State:
    old_isis_metric = subscription.iptrunk.iptrunk_isis_metric
    subscription.iptrunk.iptrunk_isis_metric = 90000
    provisioning_proxy.provision_ip_trunk(subscription, process_id, tt_number, "isis_interface", False)

    return {
        "subscription": subscription,
        "old_isis_metric": old_isis_metric,
        "label_text": "ISIS is being set to 90K by the provisioning proxy, please wait for the results",
    }
